unit plxShared;

interface
uses Windows, Messages, Classes, SysUtils, Registry, WinInet;

type
  TToken = class(Tobject)
  private
    CharText: String;
    function GetToken(Text: String): String;
  public
    Seps: set of Char; // Separators
    Text: String;  // string to handle
    LastToken: String; // token readed with first or next method
    NoToken: Boolean;  // flag that indicate that there ARENT more tokens
    MoreTokens: Boolean; // flag that indicate that there ARE more tokens
    NumTokens: Integer; // no of tokens on Text
    constructor Create;
    function Count: Integer; // count the number of tokens
    function First: String; // Find the First Token
    function Next: String; // Find the Next Token
    function Search(TokSearch: String): Boolean; // Search for a specific token
end;

procedure SHAddToRecentDocs(Flags: Word; pfname: Pointer); stdcall; external 'shell32.dll' name'SHAddToRecentDocs';
procedure AddDocToRecentList(DocFile: String);
procedure SetCDAutoRun(DoAutoRun: Boolean);
function CheckUrl(Url: string): Boolean;
procedure IESetImagesVisible(Visible: Boolean);

implementation

constructor TToken.Create;
begin
  Seps:=[];
  Text:='';
  CharText:='';
  NoToken:=True;
  MoreTokens:=False;
  LastToken:='';
end;

function TToken.Count: Integer;
var I, xLen: Integer;
    xFlag: Boolean;
begin
  NumTokens := 0;
  xLen := Length(Text);
  I := 1;
  xFlag := False;
  while (i <= xLen) and (xLen <> 0) do begin
    if (Text[I] in Seps) then
      xFlag := False
    else begin
      if (not xFlag) then begin
        xFlag := True;
        Inc(NumTokens);
      end;
    end;
    Inc(I);
  end;
  Result:=NumTokens;
end;

function TToken.Next: String;
begin
  Result := GetToken(CharText);
  LastToken := Result;
  if Result = '' then NoToken := True
  else NoToken := False;
  MoreTokens := not NoToken;
end;

function TToken.First: String;
begin
  Result := GetToken(Text);
  LastToken := Result;
  if Result='' then NoToken := True
  else NoToken := False;
  MoreTokens := not NoToken;
end;

function TToken.GetToken(Text: String): String;
var I, xLen: Integer;
    xFlag, xAgain: Boolean;
begin
  Result := '';
  xLen := Length(Text);
  I := 1;
  xFlag := False;
  xAgain := True;
  while (I <= xLen) and (xLen <> 0) and (xAgain) do begin
    if (Text[I] in Seps) then begin
      xAgain := (xAgain and (not xFlag));
      xFlag := False
    end
    else begin
      if (not xFlag) then begin
        xFlag := True;
        xAgain := true;
      end;
      Result := Result + Text[I];
    end;
    inc(I);
  end;
  CharText := Copy(Text, I, xLen);
end;

function TToken.Search(TokSearch: String): Boolean;
var xAgain: Boolean;
begin
  Result := False;
  xAgain := True;
  First;
  while (not noToken) and (xAgain) do begin
    if UpperCase(LastToken) = UpperCase(TokSearch) then begin
      Result := True;
      xAgain := False;
    end;
    Next;
  end;
end;

procedure AddDocToRecentList(DocFile: String);
begin
  SHAddTorecentDocs(2, PChar(DocFile));
end;

procedure SetCDAutoRun(DoAutoRun: Boolean);
const LAutoRun: array[Boolean] of Integer = (0,1);
var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.KeyExists('System\CurrentControlSet\Services\Class\CDROM') then
      if Reg.OpenKey('System\CurrentControlSet\Services\Class\CDROM',FALSE) then
      Reg.WriteBinaryData('AutoRun', LAutoRun[DoAutoRun], 1);
  finally
    Reg.Free;
  end;
//  ShowMessage('Your settings will take effect on the next reboot of    Windows.');
end;

function CheckUrl(Url: string): Boolean;
var hSession, hFile: hInternet;
    dwIndex,dwCodeLen: DWord;
    dwCode: array[1..20] of char;
    Res: PChar;
begin
  if Pos('http://', Lowercase(Url)) = 0 then url := 'http://' + Url;
  Result := False;
  hSession := InternetOpen('InetURL:/1.0', INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);
  if Assigned(hSession) then begin
    hFile := InternetOpenUrl(hSession, PChar(Url), nil, 0, INTERNET_FLAG_RELOAD, 0);
    dwIndex  := 0;
    dwCodeLen := 10;
    HttpQueryInfo(hfile, HTTP_QUERY_STATUS_CODE, @dwCode, dwCodeLen, dwIndex);
    Res := PChar(@dwCode);
    result:= (res ='200') or (res ='302');
    if assigned(hfile) then InternetCloseHandle(hFile);
    InternetCloseHandle(hSession);
  end;
end;

procedure IESetImagesVisible(Visible: Boolean);
var Reg: TRegistry;
    Str: string;
begin
  if Visible then Str := 'yes'
    else Str := 'no';
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\Microsoft\Internet Explorer\Main', False) then
      Reg.WriteString('Display Inline Images', Str);
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
  PostMessage(HWND_BROADCAST, WM_WININICHANGE, 0,
              Longint(PChar('HKEY_CURRENT_USER\Software\Microsoft\InternetExplorer\Main')));
end;


end.

