unit plxSpecial;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellAPI, Grids, Printers, Registry, ComCtrls, ShlObj,
  ImgList, ExtCtrls, FileCtrl;

function TextNumber(TheNumber: string): string;

implementation

const Digit: array['0'..'9'] of string = ('', '', '', '', '', '', '', '', '', '');

type TRec1 = record
    S: string[5];
    N: LongInt;
  end;
  BinTree = ^TBinTree;
  TBinTree = record
    Inf: TRec1;
    Link1,
      Link2: BinTree;
  end;

var Answer: array[1..5, 1..3] of string;

procedure PrintLine(Str: string);
var F: TextFile;
begin
  AssignFile(F, 'LPT1');
  Rewrite(F);
  WriteLn(F, Str);
  CloseFile(F);
end; {PrintLine}


function TextNumber(TheNumber: string): string;
var i, j: byte;
  Temp: string;
  Ready: boolean;
  Status: array[1..5] of boolean;

  procedure BreakIntoThrees(TheString: string);
  var Index, i, j: byte;
  begin
    for i := 1 to 5 do
      for j := 1 to 3 do
        Answer[i, j] := '';
    Answer[4, 2] := '';
    Answer[3, 2] := '';
    Answer[2, 2] := '';
    Answer[1, 2] := '';
    Index := 5;
    j := 0;
    for i := length(TheNumber) downto 1 do begin
      Answer[Index, 1] := TheNumber[i] + Answer[Index, 1];
      inc(j);
      if (j = 3) or (i = 1) then begin
        if length(Answer[Index, 1]) = 1 then Answer[Index, 1] := '00' + Answer[Index, 1];
        if length(Answer[Index, 1]) = 2 then Answer[Index, 1] := '0' + Answer[Index, 1];
        j := 0;
        dec(Index);
      end;
    end;
  end; { BreakIntoThrees }

begin
  BreakIntoThrees(TheNumber);
  for i := 1 to 5 do Status[i] := (Answer[i, 1] <> '') and (Answer[i, 1] <> '000');
  i := 5;
  repeat
    Ready := false;
    Temp := Digit[Answer[i, 1][1]];
    case Answer[i, 1][1] of
      '1': Temp := ' ';
      '2', '3': Temp := Temp + ' ';
      '4'..'9': Temp := Temp + ' ';
    end;
    if (Copy(Answer[i, 1], 2, 1) = '0') and
      (Copy(Answer[i, 1], 3, 1) = '0') then Ready := true
    else if (Copy(Answer[i, 1], 3, 1) = '0') or
      (Copy(Answer[i, 1], 2, 1) = '1') and
      (Copy(Answer[i, 1], 1, 1) <> '0') then Temp := Temp + ' ';
    if not Ready then begin
      case Answer[i, 1][2] of
        '1': begin
            case Answer[i, 1][3] of
              '1': Temp := Temp + '';
              '2': Temp := Temp + '';
              '3'..'9': Temp := Temp + Digit[Answer[i, 1][3]] + '';
            end;
            Temp := Temp + '';
            Ready := true;
          end;
        '2': Temp := Temp + '';
        '3'..'9': Temp := Temp + Digit[Answer[i, 1][2]] + '';
      end;
      if (not Ready) and (Copy(Answer[i, 1], 3, 1) = '0') then Ready := true;
    end;
    if not Ready then Temp := Temp + '  ' + Digit[Answer[i, 1][3]];
    Answer[i, 3] := Temp;
    dec(i);
  until (Answer[i, 1] = '') or (i = 0);
  for i := 1 to 5 do begin
    if Copy(Answer[i, 3], 1, 1) = ' ' then begin
      Ready := true;
      j := i - 1;
      while Ready and (j >= 1) do begin
        if Answer[j, 1] <> '' then Ready := false;
        dec(j);
      end;
      if Ready then delete(Answer[i, 3], 1, 3);
    end;
    if Copy(Answer[i, 3], 2, 1) = ' ' then begin
      Ready := true;
      j := i - 1;
      while Ready and (j >= 1) do begin
        if Answer[j, 1] <> '' then Ready := false;
        dec(j);
      end;
      if Ready then delete(Answer[i, 3], 1, 2);
    end;
  end;
  for i := 1 to 5 do begin
    if Answer[i, 3] <> '' then begin
      if (Copy(Answer[i, 1], 3, 1) = '1') and (Answer[i, 2] = '') then begin
        if Answer[i, 1] = '001' then begin
          Answer[i, 3] := '';
          Answer[i, 2] := '';
        end
        else begin
          if Copy(Answer[i, 1], 2, 2) <> '11' then begin
            delete(Answer[i, 3], length(Answer[i, 3]), 1);
            Answer[i, 3] := Answer[i, 3] + '';
          end;
        end;
      end
      else if (Copy(Answer[i, 1], 3, 1) = '1') and (Copy(Answer[i, 1], 2, 1) <> '1') then begin
        delete(Answer[i, 3], length(Answer[i, 3]) - 1, 2);
        Answer[i, 3] := Answer[i, 3] + '';
        delete(Answer[i, 2], length(Answer[i, 2]), 1);
      end;
      if (((Answer[i, 1] = '002') or
        ((Copy(Answer[i, 1], 3, 1) = '2') and (Copy(Answer[i, 1], 2, 1) <> '1')))
        and (Answer[i, 2] <> '')) then begin
        delete(Answer[i, 3], length(Answer[i, 3]), 1);
        Answer[i, 3] := Answer[i, 3] + '';
      end;
    end;
  end;
  Temp := '';
  for i := 1 to 5 do
    if (Answer[i, 1] <> '') and (Answer[i, 1] <> '000') then begin
      Temp := Temp + Answer[i, 3] + ' ' + Answer[i, 2] + ' ';
      if i <= 4 then
        case i of
          1: begin
              if (Status[2] and (not Status[3]) and (not Status[4]) and (not Status[5])) or
                ((not Status[2]) and Status[3] and (not Status[4]) and (not Status[5])) or
                ((not Status[2]) and (not Status[3]) and Status[4] and (not Status[5])) or
                ((not Status[2]) and (not Status[3]) and (not Status[4]) and Status[5])
                then Temp := Temp + '  ';
            end;
          2: begin
              if (Status[3] and (not Status[4]) and (not Status[5])) or
                ((not Status[3]) and Status[4] and (not Status[5])) or
                ((not Status[3]) and (not Status[4]) and Status[5])
                then Temp := Temp + '  ';
            end;
          3: begin
              if (Status[4] and (not Status[5])) or
                ((not Status[4]) and Status[5])
                then Temp := Temp + '  ';
            end;
          4: begin
              if Status[5] and
                ((Answer[5, 1][1] = '0') or
                ((Answer[5, 1][2] = '0') and (Answer[5, 1][3] = '0')))
                then Temp := Temp + '  ';
            end;
        end;
    end;
  for i := 1 to length(Temp) do begin
    j := i + 1;
    Ready := false;
    while (not Ready) and (j <= length(Temp)) do
      if (Copy(Temp, i, 1) = ' ') and (Copy(Temp, j, 1) = ' ') then delete(Temp, j, 1)
      else Ready := true;
  end;
  if Copy(Temp, 1, 1) = ' ' then delete(Temp, 1, 1);
  repeat
    i := Pos('   ', Temp);
    if i <> 0 then delete(Temp, i, 2);
  until i = 0;
  TextNumber := Temp { + '.'};
end; {TextNumber}

end.
