{RegisterHotKey(Form1.Handle, 1, MOD_CONTROL orMOD_ALT, 65);

procedure TForm1.WMHotMessage(var AMessage: TMessage);
begin
  if AMessage.Msg = WM_HOTKEY then DoSomething;
end;}

unit plxSystem;

interface

uses Windows, Classes, SysUtils, Forms, ShellAPI, Graphics, Registry,
     Controls, ImgList, FileCtrl, Printers, Dialogs;

type
  TShutDownType = (sdLoGoff, sdReboot, sdShutDown, sdPowerOff, sdForceShutDown);
  TCheckMode = (cmPostBraketNumber, cmPostUnderlineNumber);
  TSizeFormat = (sfJustBytes, sfBytes, sfKB, sfMB);
  TKeyModifiers = (kmShift, kmCtrl, kmAlt, kmShiftCtrl, kmShiftAlt, kmCtrlAlt, kmAll, kmNone);
  TMouseAction = (maLeftClick, maRightClick, maDoubleClickLeft, maDoubleClickRight, maMove, maMoveRandom);

function ShellExecuteFile(FileName: string): THandle;
procedure ShowTitlebar(Frm: TForm);
procedure HideTitlebar(Frm: TForm);
procedure HideTaskbar;
procedure ShowTaskbar;
procedure PrisonMouse(Rect: Trect);
procedure FreeMouse;
procedure CursorOff;
procedure CursorOn;
function HideShowAppFromTaskbar(DoShow: Boolean): boolean;
      {use:
      1. procedure CreateParams(var Params: tCreateParams); override; - in private section
      2. procedure TForm1.CreateParams(var Params: tCreateParams); - in implementation section section
         begin
           inherited;
           HideShowAppFromTaskbar(False);
         end;}
procedure Delay(msecs: integer);

function GetFileTypeName(FName: string): string;
function GetFileAttributes(FName: string): DWord;
function KeyIsDown(VirtCode: Integer): Boolean;
function KeyIsOn(KeyCode: Integer): Boolean;
function IsWinNT: Boolean; {Returns True if WinNT; otherwise, Win95.}
function CopyFileWithCheck(SourceFile, TargetDir: string; CheckMode: TCheckMode): string;
function ProgramPath: string;
procedure WinShutDown(ShutDownType: TShutDownType);
function AssociationExists(AExt: String): String;
function EnumAssoc(AppFilename: string): TStrings;
function FavouritesFolder: string;
function RemoveParams(Value: string): string;
function ForceCreateDir(PathStr: string): Boolean;
procedure PrintStrings(StringsToPrint: TStrings);
procedure SetFolderIcon(FName: string; IcoFile: string; IcoNumber: Integer);
procedure SetDefaultFolderIcon(FName: string);
function FindFiles(FPath, FMask: string; var FoundFiles: TStrings): Boolean;
function ConfirmDialog(MsgStr: string): Boolean;
function IsTimeGreater(HigherTime, LowerTime: TDateTime): Boolean;
function RunControlPanelApplication(AppletName: String): Integer;
function GetFileSize(FName: string; SizeFormat: TSizeFormat): string;
function SizeToString(FSize: DWord; SizeFormat: TSizeFormat): string;
function KeyModifiers: TKeyModifiers;
procedure MouseActivity(mLeft, mTop: Integer; MouseAction: TMouseAction);

const
  cpaAccessibility = 'access.cpl';
  cpaDialUp = 'ncpa.cpl';
  cpaPower = 'powercfg.cpl';
  cpaScanner = 'sticpl.cpl';
  cpaInternet = 'inetcpl.cpl';
  cpaHardware = 'hdwwiz.cpl';
  cpaSystem = 'sysdm.cpl';
  cpaSoftware = 'appwiz.cpl';
  cpaDisplay = 'desk.cpl';
  cpaRegionalSettings = 'intl.cpl';
  cpaJoystick = 'joy.cpl';
  cpaMouse = 'main.cpl';
  cpaMultimedia = 'mmsys.cpl';
  cpaModems = 'modem.cpl';
  cpaPhone = 'telephon.cpl';
  cpaTime = 'timedate.cpl';

implementation
uses plxStrings, plxRegistry;

function ShellExecuteFile(FileName: string): THandle;
begin
  Result := ShellExecute(0, nil, PChar(FileName), nil, nil, SW_Normal);
end;

procedure ShowTitlebar(Frm: TForm);
var Save: longint;
begin
  with Frm do begin
    if BorderStyle = bsNone then Exit;
    Save := GetWindowLong(Handle, gwl_Style);
    if (Save and ws_Caption) <> ws_Caption then begin
      case BorderStyle of
        bsSingle,
          bsSizeable: SetWindowLong(Handle, gwl_Style, Save or ws_Caption or ws_border);
        bsDialog: SetWindowLong(Handle, gwl_Style, Save or ws_Caption or ds_modalframe or ws_dlgframe);
      end;
      Height := Height + getSystemMetrics(sm_cyCaption);
      Refresh;
    end;
  end;
end;

procedure HideTitlebar(Frm: TForm);
var Save: LongInt;
begin
  with Frm do begin
    if BorderStyle = bsNone then Exit;
    Save := GetWindowLong(Handle, gwl_Style);
    if (Save and ws_Caption) = ws_Caption then begin
      case BorderStyle of
        bsSingle,
          bsSizeable: SetWindowLong(Handle, gwl_Style, Save and not (ws_Caption) or ws_border);
        bsDialog: SetWindowLong(Handle, gwl_Style, Save and (not (ws_Caption)) or ds_modalframe or ws_dlgframe);
      end;
      Height := Height - getSystemMetrics(sm_cyCaption);
      Refresh;
    end;
  end;
end;

procedure HideTaskbar;
var WindowHandle: THandle;
  WindowClass: array[0..50] of Char;
begin
  StrPCopy(@WindowClass[0], 'Shell_TrayWnd');
  WindowHandle := FindWindow(@WindowClass[0], nil);
  ShowWindow(WindowHandle, SW_HIDE);
end;

procedure ShowTaskBar;
var WindowHandle: THandle;
  WindowClass: array[0..50] of Char;
begin
  StrPCopy(@WindowClass[0], 'Shell_TrayWnd');
  WindowHandle := FindWindow(@WindowClass[0], nil);
  ShowWindow(WindowHandle, SW_RESTORE);
end;

procedure PrisonMouse(Rect: Trect);
begin
  ClipCursor(@Rect);
end;

procedure FreeMouse;
begin
  ClipCursor(nil);
end;

procedure CursorOff;
var Cstate: Integer;
begin
  Cstate := ShowCursor(True);
  while Cstate >= 0 do Cstate := ShowCursor(False);
end;

procedure CursorOn;
var Cstate: Integer;
begin
  Cstate := ShowCursor(True);
  while Cstate < 0 do Cstate := ShowCursor(True);
end;

function HideShowAppFromTaskbar(DoShow: Boolean): Boolean;
var
  ExStyle: longword;
begin
  ExStyle := GetWindowLong(Application.Handle, GWL_EXSTYLE);
  if DoShow then ExStyle := ExStyle and not WS_EX_TOOLWINDOW
  else ExStyle := ExStyle or WS_EX_TOOLWINDOW;
  ShowWindow(Application.Handle, SW_HIDE);
  SetWindowLong(Application.Handle, GWL_EXSTYLE, ExStyle);
  ShowWindow(Application.Handle, SW_SHOW);
  Result := True;
end;

procedure Delay(msecs: Integer);
var FirstTickCount: DWord;
begin
  FirstTickCount := GetTickCount;
  repeat
    Application.ProcessMessages;
  until ((GetTickCount - FirstTickCount) >= DWord(msecs));
end;

function GetFileTypeName(FName: string): string;
var FileInfo: SHFileInfo;
begin
  SHGetFileInfo(PChar(FName), 0, FileInfo, SizeOf(FileInfo), SHGFI_TYPENAME);
  Result := FileInfo.szTypeName;
end;

function GetFileAttributes(FName: string): DWord;
var FileInfo: SHFileInfo;
begin
  SHGetFileInfo(PChar(FName), 0, FileInfo, SizeOf(FileInfo), SHGFI_ATTRIBUTES);
  Result := FileInfo.dwAttributes;
//  if FileInfo.dwAttributes and SFGAO_CANCOPY = SFGAO_CANCOPY then exit;
end;

function KeyIsOn(KeyCode: Integer): Boolean;
begin
  Result := Odd(getKeyState(KeyCode));
// vk_NumLock, vk_Insert, vk_NumLock, vk_Scroll, vk_Capital (Caps Lock)
end;

function KeyIsDown(VirtCode: Integer): Boolean;
begin
  Result := (getKeyState(VirtCode) and 128) = 128;
end;

function IsWinNT: Boolean; {Returns True if WinNT; otherwise, Win95.}
var VersionInfo: TOSVersionInfo;
begin
  VersionInfo.dwOSVersionInfoSize := Sizeof(TOSVersionInfo);
  Result := GetVersionEx(VersionInfo);
  if Result then Result := VersionInfo.dwPlatformID = VER_PLATFORM_WIN32_NT;
end;

function CopyFileWithCheck(SourceFile, TargetDir: string; CheckMode: TCheckMode): string;
var TargetFile, StubStr, ExtStr: string;
  PostNumber: Integer;
begin
  PostNumber := 0;
  StubStr := ExtractFileName(SourceFile);
  ExtStr := ExtractFileExt(StubStr);
  StubStr := NormalizeDir(TargetDir) + Copy(StubStr, 1, Length(StubStr) - Length(ExtractFileExt(StubStr)));
  TargetFile := StubStr + ExtStr;
  while FileExists(TargetFile) do begin
    if CheckMode = cmPostBraketNumber then TargetFile := StubStr + '(' + IntToStr(PostNumber) + ')' + ExtStr;
    if CheckMode = cmPostUnderlineNumber then TargetFile := StubStr + '_' + IntToStr(PostNumber) + ExtStr;
    Inc(PostNumber);
  end;
  if CopyFile(PChar(SourceFile), PChar(TargetFile), False) then Result := TargetFile
  else Result := '';
end;

function ProgramPath: string;
begin
  Result := NormalizeDir(ExtractFilePath(Application.ExeName));
end;

procedure WinShutDown(ShutDownType: TShutDownType);
begin
  case ShutDownType of
    sdLoGoff: ExitWindowsEx(EWX_LOGOFF, 0);
    sdReboot: ExitWindowsEx(EWX_REBOOT, 0);
    sdShutDown: ExitWindowsEx(EWX_SHUTDOWN, 0);
    sdPowerOff: ExitWindowsEx(EWX_POWEROFF, 0);
    sdForceShutDown: ExitWindowsEx(EWX_FORCE, 0);
  end;
end;

function AssociationExists(AExt: String): String;
var StubReg: TRegistry;
    AssocKey: String;
begin
  Result := '';
  StubReg := TRegistry.Create;
  StubReg.RootKey := HKEY_CLASSES_ROOT;
  AExt := LowerCase(AExt);
  If Pos('.', AExt) = 0 then AExt := '.' + AExt;
  if not StubReg.KeyExists(AExt) then
   begin
    Result:='';
    StubReg.Free;
   end
 else
   begin
    StubReg.OpenKey(AExt, False);
    AssocKey := StubReg.ReadString('');
    StubReg.CloseKey;
    if not StubReg.OpenKey(AssocKey, FALSE) then
      begin
        StubReg.Free;
        Result:='';
        Exit;
     end;
    if not StubReg.OpenKey('Shell\Open\Command', False) then
      begin
        Result := StubReg.ReadString('');
        StubReg.Free;
        Exit;
      end;
    Result := RemoveParams(StubReg.ReadString(''));
    StubReg.Free;
  end;
end;

function EnumAssoc(AppFilename: string): TStrings;
var AList: TStringList;
    I: Integer;
    StubExt: string;
begin
  Result := TStringList.Create;
  AList := TStringList.Create;
   try
     if GetRegSubTree(HKEY_CLASSES_ROOT, AList, '') then
        for I := 0 to AList.Count-1 do
          begin
            StubExt := AList[I];
            if ExtractFileName(Uppercase(AssociationExists(StubExt))) = ExtractFileName(UpperCase(AppFilename)) then
              Result.Add(AList[I]);
          end;
   finally
     AList.Free;
   end;
end;

function FavouritesFolder: string;
var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  if Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders', False) then
    Result := Reg.ReadString('Favorites');
  Reg.Free;
end;

function RemoveParams(Value: string): string;
var I: Integer;
begin
  I := Pos('.exe', LowerCase(Value));
  if ((I < (Length(Value)-4)) and (I > 0)) then Result := Copy(Value, 1, I+3)
  else Result := Value;
end;

function ForceCreateDir(PathStr: string): Boolean;
var PathStrings: TStrings;
  I: Integer;
  StubStr: string;
begin
  StubStr := '';
  PathStrings := ParseString(UnNormalizeDir(PathStr), '\', False, False);
  for I := 0 to PathStrings.Count - 1 do begin
    StubStr := StubStr + PathStrings[I];
    if not DirectoryExists(StubStr) then CreateDir(StubStr);
    StubStr := StubStr + '\';
  end;
  PathStrings.Free;
  Result := DirectoryExists(PathStr);
end;

procedure PrintStrings(StringsToPrint: TStrings);
var
  I, Line: integer;
begin
  Line := 0;
  Printer.BeginDoc;
  for I := 0 to StringsToPrint.Count - 1 do begin
    Printer.Canvas.TextOut(0, Line, StringsToPrint[I]);
    Line := Line + Abs(Printer.Canvas.Font.Height);
    if (Line >= Printer.PageHeight) then
      Printer.NewPage;
  end;
  Printer.EndDoc;
end;

procedure SetFolderIcon(FName: string; IcoFile: string; IcoNumber: Integer);
var F: TextFile;
begin
  SetFileAttributes(PChar(FName), GetFileAttributes(PChar(FName)) and (FILE_ATTRIBUTE_SYSTEM or FILE_ATTRIBUTE_DIRECTORY));
  AssignFile(F, NormalizeDir(FName) + 'Desktop.ini');
  Rewrite(F);
  WriteLn(F, '[.ShellClassInfo]');
  WriteLn(F, 'IconFile=' + IcoFile);
  WriteLn(F, 'IconIndex=' + IntToStr(IcoNumber));
  CloseFile(F);
  SetFileAttributes(PChar(NormalizeDir(FName) + 'Desktop.ini'),
    GetFileAttributes(PChar(NormalizeDir(FName) + 'Desktop.ini')) and FILE_ATTRIBUTE_HIDDEN);
end;

procedure SetDefaultFolderIcon(FName: string);
begin
  if FileExists(NormalizeDir(FName) + 'Desktop.ini') then DeleteFile(NormalizeDir(FName) + 'Desktop.ini');
  SetFileAttributes(PChar(FName), GetFileAttributes(PChar(FName)) and
    (FILE_ATTRIBUTE_NORMAL or FILE_ATTRIBUTE_DIRECTORY));
end;

function FindFiles(FPath, FMask: string; var FoundFiles: TStrings): Boolean;
var FindHandle: THandle;
  FindData: TWIN32FindData;
begin
  Result := False;
  FoundFiles.Clear;
  FindHandle := Windows.FindFirstFile(PChar(NormalizeDir(FPath) + FMask), FindData);
  if (FindHandle <> INVALID_HANDLE_VALUE) then try
    repeat
      FoundFiles.Add(FindData.cFileName);
    until (not Windows.FindNextFile(FindHandle, FindData));
  finally
    Windows.FindClose(FindHandle);
    Result := True;
  end;
end;

function ConfirmDialog(MsgStr: string): Boolean;
begin
  Result := MessageDlg(MsgStr, mtConfirmation, [mbOk, mbCancel], 0) = mrOK;
end;

function IsTimeGreater(HigherTime, LowerTime: TDateTime): Boolean;
var HHour, HMin, HSec, HMSec, LHour, LMin, LSec, LMSec: Word;
begin
  DecodeTime(HigherTime, HHour, HMin, HSec, HMSec);
  DecodeTime(LowerTime, LHour, LMin, LSec, LMSec);
  Result := False;
  if HHour > LHour then Result := True
  else
    if HHour = LHour then
      if HMin > LMin then Result := True
      else
        if HMin = LMin then
          if HSec > LSec then Result := True;
end;

function RunControlPanelApplication(AppletName: String): Integer;
begin
  Result := WinExec(PChar('rundll32.exe shell32.dll,' +
            'Control_RunDLL ' + AppletName), SW_SHOWNORMAL);
end;

function GetFileSize(FName: string; SizeFormat: TSizeFormat): string;
var FileHandle: THandle;
begin
  FileHandle := FileOpen(FName, fmOpenRead or fmShareDenyNone);
  Result := SizeToString(Windows.GetFileSize(FileHandle, nil), SizeFormat);
  FileClose(FileHandle);
end;

function SizeToString(FSize: DWord; SizeFormat: TSizeFormat): string;
begin
  case SizeFormat of
    sfJustBytes: Result := IntToStr(FSize);
    sfBytes: Result := IntToStr(FSize) + ' bytes';
    sfKB: Result := IntToStr(Round(FSize / 1024)) + ' KB';
    sfMB: Result := IntToStr(Round(FSize / 1048576)) + ' MB';
  end;
end;

function KeyModifiers: TKeyModifiers;
var xCtrl, xAlt, xShift: Boolean;
begin
  xShift := KeyIsDown(VK_Shift);
  xCtrl := KeyIsDown(VK_Control);
  xAlt := KeyIsDown(VK_Menu);
  Result := kmNone;
  if xShift and (not xCtrl) and (not xAlt) then Result := kmShift;
  if xCtrl and (not xShift) and (not xAlt) then Result := kmCtrl;
  if xAlt and (not xCtrl) and (not xShift) then Result := kmAlt;
  if xShift and xCtrl and (not xShift) then Result := kmShiftCtrl;
  if xShift and xAlt and (not xCtrl) then Result := kmShiftAlt;
  if xCtrl and xAlt and (not xShift) then Result := kmCtrlAlt;
  if xCtrl and xAlt and xShift then Result := kmAll;
end;


procedure MouseActivity(mLeft, mTop: Integer; MouseAction: TMouseAction);
begin
  if MouseAction <> maMoveRandom then SetCursorPos(mLeft, mTop);
  case MouseAction of
    maLeftClick: begin
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
    end;
    maRightClick: begin
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
    end;
    maDoubleClickLeft: begin
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
    end;
    maDoubleClickRight: begin
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
      mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
    end;
    maMoveRandom: begin
      Randomize;
      SetCursorPos(Random(mLeft), Random(mTop))
    end;
  end;
end;


end.
